#include <bits/stdc++.h>

using namespace std;
stack <int> stek;
vector <int> ans;

int main()
{
    ios_base::sync_with_stdio(false);
    int n,k;
    cin >> n >> k;
    int t = n-k;
    for(int i = 0; i < n; i++)
    {
        int x;
        cin >> x;
        while(stek.size() > 0 && k > 0 && stek.top() > x)
        {
            stek.pop();
            k--;
        }
        stek.push(x);
    }
    while(!stek.empty())
    {
        int x = stek.top();
        stek.pop();
        ans.push_back(x);
    }
    if(ans.size() != t)while(1);
    ///
    for(int i = ans.size()-1; i >= 0; i--)
    {
        cout << ans[i] << " ";
    }
    return 0;
}